# AbAttr | pokemon-rogue-battle
Documentation for pokemon-rogue-battle

# Class AbAttr`Abstract`

#### Hierarchy (View Summary)

- AbAttr
  - BlockRecoilDamageAttr
  - DoubleBattleChanceAbAttr
  - PostBattleInitAbAttr
  - PostTeraFormChangeStatChangeAbAttr
  - ClearWeatherAbAttr
  - ClearTerrainAbAttr
  - PreDefendAbAttr
  - BlockItemTheftAbAttr
  - StabBoostAbAttr
  - PostDefendAbAttr
  - PostStatStageChangeAbAttr
  - PreAttackAbAttr
  - MoveEffectChanceMultiplierAbAttr
  - FieldPreventExplosiveMovesAbAttr
  - FieldMultiplyStatAbAttr
  - FieldMovePowerBoostAbAttr
  - StatMultiplierAbAttr
  - PostAttackAbAttr
  - AllyStatMultiplierAbAttr
  - PostSetStatusAbAttr
  - PostVictoryAbAttr
  - PostKnockOutAbAttr
  - IgnoreOpponentStatStagesAbAttr
  - IntimidateImmunityAbAttr
  - PostIntimidateStatStageChangeAbAttr
  - PostSummonAbAttr
  - CommanderAbAttr
  - PreSwitchOutAbAttr
  - PreLeaveFieldAbAttr
  - PreStatStageChangeAbAttr
  - PreSetStatusAbAttr
  - PreApplyBattlerTagAbAttr
  - BlockCritAbAttr
  - BonusCritAbAttr
  - MultCritAbAttr
  - ConditionalCritAbAttr
  - BlockNonDirectDamageAbAttr
  - BlockStatusDamageAbAttr
  - BlockOneHitKOAbAttr
  - ChangeMovePriorityAbAttr
  - IgnoreContactAbAttr
  - PreWeatherEffectAbAttr
  - PostWeatherChangeAbAttr
  - PostWeatherLapseAbAttr
  - PostTerrainChangeAbAttr
  - PostTurnAbAttr
  - PostBiomeChangeAbAttr
  - PostMoveUsedAbAttr
  - PostItemLostAbAttr
  - StatStageChangeMultiplierAbAttr
  - StatStageChangeCopyAbAttr
  - BypassBurnDamageReductionAbAttr
  - ReduceBurnDamageAbAttr
  - DoubleBerryEffectAbAttr
  - PreventBerryUseAbAttr
  - HealFromBerryUseAbAttr
  - RunSuccessAbAttr
  - CheckTrappedAbAttr
  - MaxMultiHitAbAttr
  - PostBattleAbAttr
  - PostFaintAbAttr
  - RedirectMoveAbAttr
  - BlockRedirectAbAttr
  - ReduceStatusEffectDurationAbAttr
  - FlinchEffectAbAttr
  - IncreasePpAbAttr
  - ForceSwitchOutImmunityAbAttr
  - ReduceBerryUseThresholdAbAttr
  - WeightMultiplierAbAttr
  - SyncEncounterNatureAbAttr
  - MoveAbilityBypassAbAttr
  - AlwaysHitAbAttr
  - IgnoreProtectOnContactAbAttr
  - InfiltratorAbAttr
  - ReflectStatusMoveAbAttr
  - NoTransformAbilityAbAttr
  - NoFusionAbilityAbAttr
  - IgnoreTypeImmunityAbAttr
  - IgnoreTypeStatusEffectImmunityAbAttr
  - BypassSpeedChanceAbAttr
  - PreventBypassSpeedChanceAbAttr
  - PostDamageAbAttr

- Defined in src/data/ability.ts:183

##### Index

### Constructors

constructor

### Properties

showAbility

### Methods

addCondition
apply
canApply
getCondition
getTriggerMessage

## Constructors

### constructor

- new AbAttr(showAbility?: boolean): AbAttr

  #### Parameters

  - showAbility: boolean = true

  #### Returns AbAttr

  - Defined in src/data/ability.ts:187

## Properties

### showAbility

showAbility: boolean

- Defined in src/data/ability.ts:184

## Methods

### addCondition

- addCondition(condition: AbAttrCondition): AbAttr

  #### Parameters

  - condition: AbAttrCondition

  #### Returns AbAttr

  - Defined in src/data/ability.ts:209

### apply

- apply(
  pokemon: default ,
  passive: boolean,
  simulated: boolean,
  cancelled: null | BooleanHolder ,
  args: any[],
  ): void

  Applies ability effects without checking conditions

  #### Parameters

  - pokemon: default

    The pokemon to apply this ability to

  - passive: boolean

    Whether or not the ability is a passive

  - simulated: boolean

    Whether the call is simulated

  - cancelled: null | BooleanHolder
  - args: any[]

    Extra args passed to the function. Handled by child classes.

  #### Returns void

  #### See

  `canApply`

  - Defined in src/data/ability.ts:199

### canApply

- canApply(
  pokemon: default ,
  passive: boolean,
  simulated: boolean,
  args: any[],
  ): boolean

  Returns a boolean describing whether the ability can be applied under current conditions

  #### Parameters

  - pokemon: default

    The pokemon to apply this ability to

  - passive: boolean

    Whether or not the ability is a passive

  - simulated: boolean

    Whether the call is simulated

  - args: any[]

    Extra args passed to the function. Handled by child classes.

  #### Returns boolean

  `true` if the ability can be applied, `false` otherwise

  #### See

  `apply`

  - Defined in src/data/ability.ts:223

### getCondition

- getCondition(): null | AbAttrCondition

  #### Returns null | AbAttrCondition

  - Defined in src/data/ability.ts:205

### getTriggerMessage

- getTriggerMessage(
  _pokemon: default ,
  _abilityName: string,
  ..._args: any[],
  ): null | string

  #### Parameters

  - _pokemon: default
  - _abilityName: string
  - ..._args: any[]

  #### Returns null | string

  - Defined in src/data/ability.ts:201